## bladerf 0.2019.07

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

# Indicate that this is a top-level build
set(BLADERF_TOP_LEVEL_BUILD ON)

#####################################################################
# Choose which major components to build
#####################################################################
option(ENABLE_HOST_BUILD
       "Build the bladeRF host components"
       ON
)

option(ENABLE_FX3_BUILD
       "Build the Cypress FX3 firmware component. Be sure to define FX3_SDK_PATH"
       OFF
)

#####################################################################
# Flag for development version vs tagged release
#####################################################################
option(TAGGED_RELEASE
       "Indicates that this is a tagged release.  Drops '-git' flag."
       OFF
)

if(TAGGED_RELEASE)
    set(VERSION_INFO_EXTRA "")
else()
    set(VERSION_INFO_EXTRA "git")
endif()

#####################################################################
# Build components
#####################################################################
if(ENABLE_HOST_BUILD)
    add_subdirectory(host)
else()
    message(STATUS "Skipping host component build")
endif()

if(ENABLE_FX3_BUILD)
    include(ExternalProject)
    ExternalProject_Add(fx3_firmware
        DOWNLOAD_COMMAND ""
        SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/fx3_firmware"
        CMAKE_ARGS "-DFX3_INSTALL_PATH=${FX3_INSTALL_PATH};-DCMAKE_TOOLCHAIN_FILE=${CMAKE_CURRENT_SOURCE_DIR}/fx3_firmware/cmake/fx3-toolchain.cmake"
        BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}/fx3_firmware"
        PREFIX     "${CMAKE_CURRENT_BINARY_DIR}/fx3_firmware"
        INSTALL_COMMAND ""
        BUILD_ALWAYS true
    )
else()
    message(STATUS "Skipping FX3 firmware build")
endif()

=== fx3_firmware/CMakeLists.txt ===
################################################################################
# Build bladeRF FX3 Firmware
################################################################################
cmake_minimum_required(VERSION 2.8.3)
project(bladeRF_fw C)

################################################################################
# Project configuration
################################################################################

# All build output lands in this directory:
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/output)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/output)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/output)
set(CMAKE_HELPERS_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR}/cmake/helpers)
set(CMAKE_HELPERS_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/cmake/helpers)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release")
    message(STATUS
        "Build type not specified. Defaulting to: ${CMAKE_BUILD_TYPE}"
    )
endif()

set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "Build type")

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake)
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/../host/cmake/modules)

################################################################################
# Version configuration
################################################################################

# Update these definitions when updating the firmware version
set(VERSION_INFO_MAJOR 2)
set(VERSION_INFO_MINOR 3)
set(VERSION_INFO_PATCH 2)

if(NOT DEFINED VERSION_INFO_EXTRA)
    set(VERSION_INFO_EXTRA "git")
endif()
include(Version)

set(VERSION "${VERSION_INFO}")

# Generate firmware version header file
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/src/version.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/include/version.h
    @ONLY
)

################################################################################
# Configuration options
################################################################################

option(ENABLE_BLADERF_FIRMWARE
    "Build firmware for the bladeRF 1.0"
    ON
)

################################################################################
# Build Configuration
################################################################################

# Paths for input files
set(INCLUDE_DIRS
    "${CMAKE_CURRENT_SOURCE_DIR}"
    "${CMAKE_CURRENT_BINARY_DIR}/include"
    "${CMAKE_CURRENT_SOURCE_DIR}/../firmware_common"
    "${FX3_INCLUDE_DIR}")

set(SRC_DIR "${CMAKE_CURRENT_SOURCE_DIR}/src")

# Base filenames for output files
set(BLADERF_FW bladeRF_fw_v${VERSION_INFO_BASE})

# Common source files
set(SRC_BLADERF
    "${SRC_DIR}/bladeRF.c"
    "${SRC_DIR}/cyfxbladeRFusbdscr.c"
    "${SRC_DIR}/flash.c"
    "${SRC_DIR}/fpga.c"
    "${SRC_DIR}/gpif.c"
    "${SRC_DIR}/logger.c"
    "${SRC_DIR}/rf.c"
    "${SRC_DIR}/spi_flash_lib.c"
    "${FX3_FW_COMMON_DIR}/cyfx_gcc_startup.S"
    "${FX3_FW_COMMON_DIR}/cyfxtx.c"
    "${SRC_DIR}/bladeRF1.c"
    "${SRC_DIR}/bladeRF2.c"
)

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(CMAKE_C_FLAGS "-O0 -g")
else()
    set(CMAKE_C_FLAGS "-O2")
endif()

set(CMAKE_C_FLAGS
    "${CMAKE_C_FLAGS} -Wall -Wextra -Wno-unused-parameter -DCYU3P_FX3=1 \
     -D__CYU3P_TX__=1 -mcpu=arm926ej-s -mthumb-interwork"
)

include_directories(${INCLUDE_DIRS})
enable_language(ASM)

set(CMAKE_EXE_LINKER_FLAGS
    "-Wl,--entry,CyU3PFirmwareEntry \
     -Wl,-T,\"${FX3_LINKER_FILE}\" \
     -Wl,-d -Wl,--gc-sections \
     -Wl,--no-wchar-size-warning"
)

################################################################################
# Build or find required host utililities
################################################################################

if(FX3_WINDOWS_HOST)
    set(ELF2IMG ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/elf2img.exe)

    # A prebuild-elf2img binary ships with the FX3 SDK.
    # Just copy it to our output directory for simplicity.
    add_custom_command(
        OUTPUT ${ELF2IMG}
        COMMAND ${CMAKE_COMMAND} -E copy ${FX3_ELF2IMG} ${ELF2IMG}
    )

    add_custom_target(elf2img ALL DEPENDS ${ELF2IMG})
else()
    # Otherwise, we need to build it ourselves
    include(ExternalProject)
    ExternalProject_Add(elf2img
        DOWNLOAD_COMMAND ""
        SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/util/elf2img/"
        CMAKE_ARGS "-DFX3_ELF2IMG=${FX3_ELF2IMG};-DCMAKE_RUNTIME_OUTPUT_DIRECTORY=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}"
        INSTALL_COMMAND ""
    )
    set(ELF2IMG ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/elf2img)
endif()

################################################################################
# Build firmware ELF
################################################################################

# Build an archive of the common object files.
add_library(bladeRF_fx3 STATIC ${SRC_BLADERF})
target_link_libraries(bladeRF_fx3
    "${FX3_LIBRARY_DIR}/libcyfxapi.a"
    "${FX3_LIBRARY_DIR}/libcyu3lpp.a"
    "${FX3_LIBRARY_DIR}/libcyu3threadx.a"
)

if(ENABLE_BLADERF_FIRMWARE)
    add_executable(${BLADERF_FW}.elf ${SRC_BLADERF})
    target_link_libraries(${BLADERF_FW}.elf
        "${FX3_LIBRARY_DIR}/libcyfxapi.a"
        "${FX3_LIBRARY_DIR}/libcyu3lpp.a"
        "${FX3_LIBRARY_DIR}/libcyu3threadx.a"
        "${ARM_NONE_EABI_LIBC}"
        "${ARM_NONE_EABI_LIBGCC}"
        bladeRF_fx3
    )
    set_target_properties(${BLADERF_FW}.elf
        PROPERTIES LINK_FLAGS "-Wl,-Map,output/${BLADERF_FW}.map")
endif()

################################################################################
# Create bootable image from firmware ELF
################################################################################

set(ELF2IMG_WORK_DIR "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}")

if(ENABLE_BLADERF_FIRMWARE)
    add_custom_command(
        OUTPUT ${ELF2IMG_WORK_DIR}/${BLADERF_FW}.img
        COMMAND ${ELF2IMG} -i ${ELF2IMG_WORK_DIR}/${BLADERF_FW}.elf -o ${ELF2IMG_WORK_DIR}/${BLADERF_FW}.img
        DEPENDS ${ELF2IMG_WORK_DIR}/${BLADERF_FW}.elf
        COMMENT "Creating ${BLADERF_FW}.img. Interrupt vector removal note is expected."
    )

    add_custom_target(${BLADERF_FW}.img ALL
        DEPENDS elf2img ${ELF2IMG_WORK_DIR}/${BLADERF_FW}.elf ${ELF2IMG_WORK_DIR}/${BLADERF_FW}.img)
endif()

################################################################################
# Drop our .gdbinit sample into our build output directory for convenience
################################################################################
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/gdb/gdbinit_sample
               ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/.gdbinit
               @ONLY)

=== host/libraries/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
add_subdirectory(libbladeRF)
add_subdirectory(libbladeRF_test)

=== analogdevicesinc/no-OS/ad9739a-fmc-ebz/Makefile ===
FILE=README.md
VARIABLE := $(shell cat $(FILE))
files := $(subst ],,$(subst [,,$(strip $(foreach dir,$(VARIABLE),$(if $(findstring [.,$(dir)),$(dir))))))

project := sdk_project
hdf_file:= system_top.hdf
elf_file := $(project)/workspace/sw/Debug/sw.elf
fpga_processor :=sys_mb
fpga_processor +=ps7_cortexa9_0
fpga_processor +=ps7_cortexa9_1
libxil:=$(foreach name,$(fpga_processor),$(if $(wildcard $(project)/workspace/bsp/$(name)/lib/libxil.a),$(project)/workspace/bsp/$(name)/lib/libxil.a))


src := $(foreach dir,$(files),$(wildcard $(dir)*.c))
src += $(foreach dir,$(files),$(wildcard $(dir)*.h))


all:$(elf_file)

$(elf_file): $(libxil) $(src)
	@echo 'creating project'
	xsct ../build_scripts/xilinx/create_sdk_project.tcl $(hdf_file) $(project)

$(libxil): $(hdf_file)
	rm -rf $(project)

=== analogdevicesinc/no-OS/v4l2_config/Makefile ===

EXEC = v4l2_config
SYMBOLS = -DINFO
CFLAGS = -Wall -Werror -Wextra -O0 $(SYMBOLS)

all: $(EXEC)

$(EXEC): example.c v4l2_config.c
	$(CC) $+ $(CFLAGS) -o $(EXEC)

clean:
	rm -rf $(EXEC)

=== host/libraries/libbladeRF/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.5)
project(libbladeRF C)


################################################################################
# Version information
################################################################################

set(VERSION_INFO_MAJOR  2)
set(VERSION_INFO_MINOR  2)
set(VERSION_INFO_PATCH  1)

if(NOT DEFINED VERSION_INFO_EXTRA)
    set(VERSION_INFO_EXTRA "git")
endif()
include(Version)

set(VERSION "${VERSION_INFO}")
set(LIBVER "${VERSION_INFO_BASE}")

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/src/version.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/src/version.h
    @ONLY
)

if(MSVC)
    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/bladerf.rc.in
        ${CMAKE_CURRENT_BINARY_DIR}/bladerf.rc
        @ONLY
    )
endif()

if (NOT CMAKE_INSTALL_LIBDIR)
include(GNUInstallDirs)
endif (NOT CMAKE_INSTALL_LIBDIR)

if (NOT CMAKE_INSTALL_DOCDIR)
include(GNUInstallDirs)
endif (NOT CMAKE_INSTALL_DOCDIR)

# Fall back to just "lib" if the item provided by GNUInstallDirs doesn't exist
# For example, on Ubuntu 13.10 with CMake 2.8.11.2,
# /usr/lib/${CMAKE_LIBRARY_ARCHITECTURE} doesn't exist.
if (NOT EXISTS "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
    message(STATUS "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR} does not exist. Defaulting libbladeRF install location to ${CMAKE_INSTALL_PREFIX}/lib.")
    set(CMAKE_INSTALL_LIBDIR lib)
endif()


################################################################################
# Configuration options
################################################################################

option(ENABLE_LIBBLADERF_LOGGING "Enable log messages in libbladeRF." ON)

option(ENABLE_LIBBLADERF_SYSLOG "Enable logging to syslog (Linux/OSX)" OFF)

option(BUILD_LIBBLADERF_DOCUMENTATION "Build libbladeRF documentation. Requries Doxygen." ${BUILD_DOCUMENTATION})
if(NOT ${BUILD_DOCUMENTATION})
    set(BUILD_LIBBLADERF_DOCUMENTATION OFF)
endif()

option(BUILD_LIBBLADERF_DOC_EXAMPLES "Compile examples that are included in Doxygen documentation (mainly for QA purposes)." ${BUILD_LIBBLADERF_DOCUMENTATION})

option(ENABLE_LIBBLADERF_SYNC_LOG_VERBOSE
      "Enable log_verbose() calls in the sync interface's data path. Note that this may harm performance."
      OFF
)

option(ENABLE_LIBBLADERF_NIOS_ACCESS_LOG_VERBOSE
       "Enable log_verbose() calls on frequently-used functions in nios_access.c. Note that this may produce a lot of log output."
       OFF
)

option(ENABLE_LOCK_CHECKS
       "Enable checks for lock acquisition failures (e.g., deadlock)"
       OFF
)

option(ENABLE_USB_DEV_RESET_ON_OPEN
       "Perform a USB port reset when opening a device. This works around an issue on some Linux USB 3.0 setups that prevents a device from being opened after an application crash or unclean exit."
       ${BLADERF_OS_LINUX}
)

option(ENABLE_RFIC_TIMING_CALIBRATION
       "Perform timing calibration on the RFIC digital interface during initialization. This is only implemented on AD936x-based hardware."
       OFF
)


##############################
# Backend Support
##############################

option(ENABLE_BACKEND_USB
    "Enable USB backends. Required when using the bladeRF with a host machine."
    ON
)

option(ENABLE_BACKEND_LIBUSB
    "Enable libusb backend support."
    ${LIBUSB_FOUND}
)

option(ENABLE_BACKEND_CYAPI
    "Enable CYAPI backend support."
    ${CYAPI_FOUND}
)

option(ENABLE_BACKEND_DUMMY
    "Enable dummy backend support. This is only useful for some developers."
    OFF
)

# Ensure we've got at least one backend enabled
if(NOT ENABLE_BACKEND_LIBUSB
   AND NOT ENABLE_BACKEND_LINUX_DRIVER
   AND NOT ENABLE_BACKEND_CYAPI
   AND NOT ENABLE_BACKEND_DUMMY)
    message(FATAL_ERROR
            "No libbladeRF backends are enabled. "
            "Please enable one or more backends." )
endif()

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/src/backend/backend_config.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/src/backend/backend_config.h
    @ONLY
)


################################################################################
# Additional compiler options
################################################################################

if(ENABLE_LIBBLADERF_LOGGING)
    add_definitions(-DLOGGING_ENABLED)
endif()

if(ENABLE_LIBBLADERF_SYSLOG)
    add_definitions(-DLOG_SYSLOG_ENABLED)
endif()

if(ENABLE_LOCK_CHECKS)
    add_definitions(-DENABLE_LOCK_CHECKS)
endif()

if(ENABLE_RFIC_TIMING_CALIBRATION)
    add_definitions(-DENABLE_AD9361_DIGITAL_INTERFACE_TIMING_VERIFICATION)
endif()

if(${CMAKE_C_COMPILER_ID} STREQUAL "GNU" OR
   ${CMAKE_C_COMPILER_ID} STREQUAL "Clang")

    # Doing this manually instead of via add_compiler_export_flags() since
    # the GenerateExportHeader module appears to break for C-only projects:
    #
    # http://www.cmake.org/pipermail/cmake-commits/2012-August/013142.html
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden")
endif()

# We define LIBBLADERF_SEARCH_PREFIX to specify where libbladeRF should look
# for files, such as FPGA bitstreams to autoload.
#
# This defaults to the value of ${CMAKE_INSTALL_PREFIX}. However,
# users may wish to override when cross compiling.
if(LIBBLADERF_SEARCH_PREFIX_OVERRIDE)
    add_definitions(-DLIBBLADERF_SEARCH_PREFIX="${LIBBLADERF_SEARCH_PREFIX_OVERRIDE}")
else()
    add_definitions(-DLIBBLADERF_SEARCH_PREFIX="${CMAKE_INSTALL_PREFIX}")
endif()


################################################################################
# Include paths
################################################################################

set(LIBBLADERF_INCLUDES
    ${CMAKE_CURRENT_SOURCE_DIR}/include
    ${CMAKE_CURRENT_SOURCE_DIR}/src
    ${BLADERF_HOST_COMMON_INCLUDE_DIRS}
    ${BLADERF_FW_COMMON_INCLUDE_DIR}
    ${BLADERF_FPGA_COMMON_INCLUDE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}/src
)


################################################################################
# Build dependencies
################################################################################

if(MSVC)
    set(LIBBLADERF_INCLUDES ${LIBBLADERF_INCLUDES} ${MSVC_C99_INCLUDES})

    find_package(LibPThreadsWin32 REQUIRED)
    if(LIBPTHREADSWIN32_FOUND)
        set(HAVE_THREADS true)
        set(LIBBLADERF_INCLUDES
            ${LIBBLADERF_INCLUDES} ${LIBPTHREADSWIN32_INCLUDE_DIRS})
        set(LIBBLADERF_LIBS
            ${LIBBLADERF_LIBS} ${LIBPTHREADSWIN32_LIBRARIES})
    else()
        set(HAVE_THREADS false)
    endif()
else(MSVC)
    find_package(Threads REQUIRED)
    if(Threads_FOUND)
        set(HAVE_THREADS true)
    else()
        set(HAVE_THREADS false)
    endif()
endif(MSVC)

if(BLADERF_OS_OSX)
    set(LIBBLADERF_INCLUDES ${LIBBLADERF_INCLUDES} /usr/include/malloc)
endif()

if (NOT HAVE_THREADS)
    message(FATAL_ERROR "pthreads not found. This is required to build libbladeRF.")
endif()

if(NOT ENABLE_BACKEND_USB)
    set(ENABLE_BACKEND_LIBUSB OFF)
    set(ENABLE_BACKEND_LINUX_DRIVER OFF)
endif()

if(ENABLE_BACKEND_LIBUSB)
    if(NOT LIBUSB_FOUND)
        message(FATAL_ERROR "libusb-1.0 not found. This is required to use the libbladeRF libusb backend. For binary releases, try setting LIBUSB_PATH.")
    else(NOT LIBUSB_FOUND)
        if(LIBUSB_VERSION)
            if(NOT LIBUSB_VERSION VERSION_LESS "1.0.10")
                add_definitions(-DHAVE_LIBUSB_GET_VERSION)
            endif()

            if(WIN32)
                # We require v1.0.19 because it provides Windows 8 USB 3.0
                # speed detection fixes, additional AMD/Intel USB 3.0 root
                # hub support, and some fixes to issues reported on v1.0.18
                # that yielded corrupted samples.
                if(${LIBUSB_VERSION} VERSION_LESS "1.0.19")
                    message(FATAL_ERROR "libusb v1.0.19 is required in Windows.\n"
                                        "Please update libusb or consider using the Cypress backend if this is not possible.\n"
                                        "Detected version: ${LIBUSB_VERSION}\n")
                endif()
            elseif(APPLE)
                # A number of important changes were included in libusb
                # v1.0.16 hrough v1.0.18, including SuperSpeed support, 64-bit support,
                # and various build and crash fixes.
                if(${LIBUSB_VERSION} VERSION_LESS "1.0.18")
                    message(FATAL_ERROR "libusb v1.0.18 is required in OS X. Please update libusb."
                                        "Detected version: ${LIBUSB_VERSION}\n")
                endif()
            elseif(UNIX)
                # A number of reported issues supposedly became resolved after
                # updating to >= 1.0.16.
                if(${LIBUSB_VERSION} VERSION_LESS "1.0.16")
                    message(WARNING "\nlibusb >= 1.0.16 is HIGHLY recommended. "
                                    "If you experience issues or poor performance, please try updating libusb.\n"
                                    "Detected version: ${LIBUSB_VERSION}")
                endif()
            else()
                message(WARNING "Unexpected system type. Please report this warning to developers.")
            endif()
        elseif(BLADERF_OS_FREEBSD)
            message(STATUS "Using FreeBSD's built-in libusb implementation.")
        else()
            message(WARNING "Not checking libbladeRF/libusb compatibility because LIBUSB_VERSION is not defined.")
        endif()
        set(LIBBLADERF_INCLUDES ${LIBBLADERF_INCLUDES} ${LIBUSB_INCLUDE_DIRS})
    endif(NOT LIBUSB_FOUND)
endif(ENABLE_BACKEND_LIBUSB)

if(ENABLE_BACKEND_CYAPI)
    find_package(CyAPI REQUIRED)
    set(LIBBLADERF_INCLUDES ${LIBBLADERF_INCLUDES} ${CYAPI_INCLUDE_DIRS})
endif(ENABLE_BACKEND_CYAPI)

if(MSVC)
    set(LIBBLADERF_INCLUDES ${LIBBLADERF_INCLUDES}
        ${LIBPTHREADSWIN32_INCLUDE_DIRS})
endif()

if(ENABLE_LIBBLADERF_SYNC_LOG_VERBOSE AND ENABLE_LIBBLADERF_LOGGING)
    add_definitions(-DENABLE_LIBBLADERF_SYNC_LOG_VERBOSE)
endif()

if(ENABLE_LIBBLADERF_NIOS_ACCESS_LOG_VERBOSE AND ENABLE_LIBBLADERF_LOGGING)
    add_definitions(-DENABLE_LIBBLADERF_NIOS_ACCESS_LOG_VERBOSE)
endif()

if(ENABLE_USB_DEV_RESET_ON_OPEN)
    add_definitions(-DENABLE_USB_DEV_RESET_ON_OPEN=1)
endif()

if(BUILD_AD936X)
    set(LIBBLADERF_LIBS ${LIBBLADERF_LIBS} ad936x)
endif(BUILD_AD936X)

include_directories(${LIBBLADERF_INCLUDES})


################################################################################
# Configure source files
################################################################################
set(LIBBLADERF_SOURCE_BLADERF2
        ${BLADERF_FPGA_COMMON_SOURCE_DIR}/ad936x_helpers.c
        ${BLADERF_FPGA_COMMON_SOURCE_DIR}/bladerf2_common.c
        src/board/bladerf2/bladerf2.c
        src/board/bladerf2/capabilities.c
        src/board/bladerf2/common.c
        src/board/bladerf2/compatibility.c
        src/board/bladerf2/rfic_fpga.c
        src/board/bladerf2/rfic_host.c
)

set(LIBBLADERF_SOURCE
        src/backend/backend.c
        src/driver/spi_flash.c
        src/driver/fx3_fw.c
        src/driver/fpga_trigger.c
        src/driver/si5338.c
        src/driver/ina219.c
        src/driver/dac161s055.c
        src/driver/smb_clock.c
        src/board/bladerf1/bladerf1.c
        src/board/bladerf1/capabilities.c
        src/board/bladerf1/compatibility.c
        src/board/bladerf1/calibration.c
        src/board/bladerf1/flash.c
        src/board/bladerf1/image.c
        src/board/board.c
        src/expansion/xb100.c
        src/expansion/xb200.c
        src/expansion/xb300.c
        src/streaming/async.c
        src/streaming/sync.c
        src/streaming/sync_worker.c
        src/init_fini.c
        src/helpers/timeout.c
        src/helpers/file.c
        src/helpers/version.c
        src/helpers/wallclock.c
        src/helpers/interleave.c
        src/helpers/configfile.c
        src/version.h
        src/devinfo.c
        src/bladerf.c
        ${BLADERF_HOST_COMMON_SOURCE_DIR}/sha256.c
        ${BLADERF_HOST_COMMON_SOURCE_DIR}/conversions.c

=== host/libraries/libbladeRF_test/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

add_subdirectory(test_async)
add_subdirectory(test_bootloader_recovery)
add_subdirectory(test_c)
#add_subdirectory(test_config_file)
add_subdirectory(test_cpp)
add_subdirectory(test_ctrl)
add_subdirectory(test_freq_hop)
add_subdirectory(test_fw_check)
add_subdirectory(test_open)
add_subdirectory(test_parse)
add_subdirectory(test_peripheral_timing)
add_subdirectory(test_repeater)
add_subdirectory(test_quick_retune)
add_subdirectory(test_repeated_stream)
add_subdirectory(test_rx_discont)
add_subdirectory(test_scheduled_retune)
add_subdirectory(test_sync)
add_subdirectory(test_timestamps)
add_subdirectory(test_tune_timing)
add_subdirectory(test_unused_sync)
add_subdirectory(test_version)
add_subdirectory(test_digital_loopback)
add_subdirectory(test_interleaver)

=== host/misc/udev/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    SET(SYSTEM_IS_LINUX TRUE)
    SET(UDEV_OPTION_DEFAULT ON)
else()
    SET(SYSTEM_IS_LINUX FALSE)
    SET(UDEV_OPTION_DEFAULT OFF)
endif()

option(INSTALL_UDEV_RULES
    "Install udev rules for the nuand bladeRF"
    ${UDEV_OPTION_DEFAULT}
)

set(UDEV_RULES_PATH
    "/etc/udev/rules.d"
    CACHE STRING
    "Target directory for udev rule installation. Ensure you have permissions to write to this directory."
)

set(BLADERF_GROUP "plugdev" CACHE STRING "Group to associate bladeRF devices with in udev rules")

set(BLADERF_UDEV_FILES
    88-nuand-bladerf1.rules
    88-nuand-bladerf2.rules
    88-nuand-bootloader.rules
)

if(SYSTEM_IS_LINUX)
    if(INSTALL_UDEV_RULES)
        message(STATUS  "nuand bladeRF udev rules will be installed to '${UDEV_RULES_PATH}' upon running 'make install'")
        foreach(udevfile IN ITEMS ${BLADERF_UDEV_FILES})
            configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${udevfile}.in
                           ${CMAKE_CURRENT_BINARY_DIR}/${udevfile}
                           @ONLY
                          )

            install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${udevfile}
                    DESTINATION ${UDEV_RULES_PATH}
                    COMPONENT "udev_rules")
        endforeach(udevfile)
    else()
        message(STATUS
                "nuand bladeRF udev rules will not be installed because INSTALL_UDEV_RULES=OFF"
               )
    endif(INSTALL_UDEV_RULES)
else()
    if(INSTALL_UDEV_RULES)
        message(STATUS "udev rules not supported on this platform. Hide this message via -DINSTALL_UDEV_RULES=OFF")
    endif(INSTALL_UDEV_RULES)
endif()

=== host/utilities/bladeRF-cli/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(bladeRF-cli C)

################################################################################
# Version information
################################################################################

set(VERSION_INFO_MAJOR  1)
set(VERSION_INFO_MINOR  8)
set(VERSION_INFO_PATCH  0)

if(NOT DEFINED VERSION_INFO_EXTRA)
    set(VERSION_INFO_EXTRA "git")
endif()
include(Version)

set(VERSION "${VERSION_INFO}")

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/src/version.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/src/version.h
    @ONLY
)

################################################################################
# Build dependencies
################################################################################
find_package(LibTecla)
find_package(LibEdit)

if(MSVC)
    find_package(LibPThreadsWin32 REQUIRED)
else(MSVC)
	find_package(Threads REQUIRED)
endif(MSVC)

find_program(PANDOC_EXECUTABLE pandoc)
find_program(BASH_EXECUTABLE bash)

if(PANDOC_EXECUTABLE AND BASH_EXECUTABLE)
    set(CAN_BUILD_INTERACTIVE_HELP ON)
else()
    set(CAN_BUILD_INTERACTIVE_HELP OFF)
endif()

################################################################################
# Configuration options
################################################################################

option(ENABLE_LIBTECLA
        "Enable the use of libtecla, if available.")

option(ENABLE_LIBEDIT
        "Enable the use of libtecla, if available.")

option(BUILD_BLADERF_CLI_DOCUMENTATION
        "Build bladeRF-cli man page. Requires help2man."
        ${BUILD_DOCUMENTATION})

option(BUILD_BLADERF_CLI_INTERACTIVE_HELP
        "Rebuild bladeRF-cli interactive help. Requires pandoc."
        ${CAN_BUILD_INTERACTIVE_HELP})

if(NOT ${BUILD_DOCUMENTATION})
    set(BUILD_BLADERF_CLI_DOCUMENTATION OFF)
endif()

if((NOT CAN_BUILD_INTERACTIVE_HELP) AND (BUILD_BLADERF_CLI_INTERACTIVE_HELP))
    message(FATAL_ERROR "BUILD_BLADERF_CLI_INTERACTIVE_HELP was forced ON, "
            "but there are missing prerequisites!")
endif()

if(ENABLE_LIBTECLA)
    if((NOT LIBTECLA_INCLUDE_DIR) OR (NOT LIBTECLA_LIBRARIES))
        message(FATAL_ERROR "ENABLE_LIBTECLA was forced ON, but libtecla "
                "cannot be found!")
    endif()
endif()
if(ENABLE_LIBEDIT)
    if((NOT LIBEDIT_INCLUDE_DIR) OR (NOT LIBEDIT_LIBRARIES))
        message(FATAL_ERROR "ENABLE_LIBEDIT was forced ON, but editline "
                "cannot be found!")
    endif()
endif()

################################################################################
# Regenerate interactive help
################################################################################
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/src/cmd/doc)

if(BUILD_BLADERF_CLI_INTERACTIVE_HELP)
    # Do a quick test to make sure we have everything we need...
    execute_process(
        COMMAND ${BASH_EXECUTABLE}
            ${CMAKE_CURRENT_SOURCE_DIR}/src/cmd/doc/generate.bash
                --pandoc=${PANDOC_EXECUTABLE}
                --test
                ${CMAKE_CURRENT_SOURCE_DIR}/src/cmd/doc/interactive-help.md
        RESULT_VARIABLE INTERACTIVE_HELP_GENERATOR_FAILED
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/src/cmd/doc
    )

    if(INTERACTIVE_HELP_GENERATOR_FAILED)
        message(FATAL_ERROR "generate.bash failed! Try disabling "
                "BUILD_BLADERF_CLI_INTERACTIVE_HELP, or fix the above error.")
    endif()

    # Run the generation script during build
    message(STATUS "Will regenerate bladeRF-cli interactive help")
    add_custom_command(
        OUTPUT src/cmd/doc/cmd_help.h src/cmd/doc/cmd_help.man
        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/src/cmd/doc/generate.bash
        COMMAND ${BASH_EXECUTABLE}
            ${CMAKE_CURRENT_SOURCE_DIR}/src/cmd/doc/generate.bash
                --pandoc=${PANDOC_EXECUTABLE}
                ${CMAKE_CURRENT_SOURCE_DIR}/src/cmd/doc/interactive-help.md
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/src/cmd/doc
    )
else()
    # Re-use old cmd_help.h and cmd_help.man
    message(STATUS "Reusing existing interactive help for bladeRF-cli")
    add_custom_command(
        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/src/cmd/doc/cmd_help.h.in
        OUTPUT src/cmd/doc/cmd_help.h
        COMMAND ${CMAKE_COMMAND} -E copy 
            ${CMAKE_CURRENT_SOURCE_DIR}/src/cmd/doc/cmd_help.h.in
            ${CMAKE_CURRENT_BINARY_DIR}/src/cmd/doc/cmd_help.h
    )
    add_custom_command(
        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/src/cmd/doc/cmd_help.man.in
        OUTPUT src/cmd/doc/cmd_help.man
        COMMAND ${CMAKE_COMMAND} -E copy
            ${CMAKE_CURRENT_SOURCE_DIR}/src/cmd/doc/cmd_help.man.in
            ${CMAKE_CURRENT_BINARY_DIR}/src/cmd/doc/cmd_help.man
    )
endif()

################################################################################
# Include paths
################################################################################
set(CLI_INCLUDE_DIRS
       ${CMAKE_CURRENT_SOURCE_DIR}/src
       ${CMAKE_CURRENT_SOURCE_DIR}/src/cmd
       ${CMAKE_CURRENT_SOURCE_DIR}/src/input
       ${CMAKE_CURRENT_BINARY_DIR}/src
       ${CMAKE_CURRENT_BINARY_DIR}/src/cmd
       ${BLADERF_HOST_COMMON_INCLUDE_DIRS}
       ${libbladeRF_SOURCE_DIR}/include
       ${BLADERF_FW_COMMON_INCLUDE_DIR}
)

if(MSVC)
    set(CLI_INCLUDE_DIRS ${CLI_INCLUDE_DIRS} ${MSVC_C99_INCLUDES})
endif()


message(STATUS "libtecla ${ENABLE_LIBTECLA} ${LIBTECLA_FOUND}")
message(STATUS "libedit ${ENABLE_LIBEDIT} ${LIBEDIT_FOUND}")
if(ENABLE_LIBTECLA OR (LIBTECLA_FOUND AND NOT ENABLE_LIBEDIT))
    message(STATUS "libtecla support enabled")
    set(ENABLE_LIBTECLA ON)
    set(CLI_INCLUDE_DIRS ${CLI_INCLUDE_DIRS} ${LIBTECLA_INCLUDE_DIR})
elseif(ENABLE_LIBEDIT OR LIBEDIT_FOUND)
    message(STATUS "editline support enabled")
    set(ENABLE_LIBEDIT ON)
    set(CLI_INCLUDE_DIRS ${CLI_INCLUDE_DIRS} ${LIBEDIT_INCLUDE_DIR})
endif()

if(MSVC)
    set(CLI_INCLUDE_DIRS ${CLI_INCLUDE_DIRS}
        ${BLADERF_HOST_COMMON_INCLUDE_DIRS}/windows
        ${LIBPTHREADSWIN32_INCLUDE_DIRS}
    )
endif()

if(APPLE)
    set(CLI_INCLUDE_DIRS ${CLI_INCLUDE_DIRS}
        ${BLADERF_HOST_COMMON_INCLUDE_DIRS}/osx
    )
endif()

include_directories(${CLI_INCLUDE_DIRS})

################################################################################
# Configure source files
################################################################################
set(BLADERF_CLI_SOURCE
        src/main.c
        src/common.c
        src/cmd/calibrate.c
        src/cmd/cmd.c
        src/cmd/doc/cmd_help.h
        src/cmd/erase.c
        src/cmd/flash_backup.c
        src/cmd/flash_image.c
        src/cmd/flash_init_cal.c
        src/cmd/flash_restore.c
        src/cmd/fw_log.c
        src/cmd/info.c
        src/cmd/jump_boot.c
        src/cmd/lms_reg_info.c
        src/cmd/load.c
        src/cmd/mimo.c
        src/cmd/open.c
        src/cmd/peek.c
        src/cmd/peekpoke.c
        src/cmd/poke.c
        src/cmd/printset.c
        src/cmd/printset_hardware.c
        src/cmd/printset_impl.c
        src/cmd/printset_xb.c
        src/cmd/probe.c
        src/cmd/recover.c
        src/cmd/rx.c
        src/cmd/rxtx.c
        src/cmd/trigger.c
        src/cmd/tx.c
        src/cmd/version.c
        src/cmd/xb.c
        src/cmd/xb100.c
        src/cmd/xb200.c
        src/cmd/xb300.c
        src/input/input.c
        src/input/script.c
        ${BLADERF_HOST_COMMON_SOURCE_DIR}/conversions.c
        ${BLADERF_HOST_COMMON_SOURCE_DIR}/dc_calibration.c
        ${BLADERF_HOST_COMMON_SOURCE_DIR}/log.c
        ${BLADERF_HOST_COMMON_SOURCE_DIR}/str_queue.c
        ${BLADERF_HOST_COMMON_SOURCE_DIR}/parse.c
)

# Select the input mode (and script handling) backend
if(ENABLE_LIBTECLA)
    set(BLADERF_CLI_SOURCE ${BLADERF_CLI_SOURCE} src/input/tecla.c)
elseif(ENABLE_LIBEDIT)
    set(BLADERF_CLI_SOURCE ${BLADERF_CLI_SOURCE} src/input/editline.c)
else()
    set(BLADERF_CLI_SOURCE ${BLADERF_CLI_SOURCE} src/input/fgets.c)
endif()

if(MSVC)
    set(BLADERF_CLI_SOURCE ${BLADERF_CLI_SOURCE}
            ${BLADERF_HOST_COMMON_SOURCE_DIR}/windows/getopt_long.c
            ${BLADERF_HOST_COMMON_SOURCE_DIR}/windows/clock_gettime.c
            ${BLADERF_HOST_COMMON_SOURCE_DIR}/windows/nanosleep.c
            ${BLADERF_HOST_COMMON_SOURCE_DIR}/windows/setenv.c
    )
endif()

if(APPLE)
    set(BLADERF_CLI_SOURCE ${BLADERF_CLI_SOURCE}
            ${BLADERF_HOST_COMMON_SOURCE_DIR}/osx/clock_gettime.c
    )
endif()

add_executable(bladeRF-cli ${BLADERF_CLI_SOURCE})

################################################################################
# Build configuration
################################################################################
set(CLI_LINK_LIBRARIES
    libbladerf_shared
    ${CMAKE_THREAD_LIBS_INIT}
)

if(NOT MSVC)
    set(CLI_LINK_LIBRARIES ${CLI_LINK_LIBRARIES} m)
endif()

if(ENABLE_LIBTECLA)
    set(CLI_LINK_LIBRARIES ${CLI_LINK_LIBRARIES} ${LIBTECLA_LIBRARIES})

    # On a few tests Linux distros, libtecla is not build against
    # ncurses. However, folks have reported that builds on OSX use it
    if(CMAKE_HOST_APPLE)
        set(CLI_LINK_LIBRARIES ${CLI_LINK_LIBRARIES} ncurses)
    endif(CMAKE_HOST_APPLE)
elseif(ENABLE_LIBEDIT)
    set(CLI_LINK_LIBRARIES ${CLI_LINK_LIBRARIES} ${LIBEDIT_LIBRARIES})
endif(ENABLE_LIBTECLA)

if(LIBPTHREADSWIN32_FOUND)
    set(CLI_LINK_LIBRARIES ${CLI_LINK_LIBRARIES} ${LIBPTHREADSWIN32_LIBRARIES})
endif()

if(LIBC_VERSION)
    # clock_gettime() was moved from librt -> libc in 2.17
    if(${LIBC_VERSION} VERSION_LESS "2.17")
        set(CLI_LINK_LIBRARIES ${CLI_LINK_LIBRARIES} rt)
    endif()
endif()

target_link_libraries(bladeRF-cli ${CLI_LINK_LIBRARIES})

################################################################################
# Man pages
################################################################################
if(BUILD_BLADERF_CLI_DOCUMENTATION)
    find_program(HELP2MAN_EXECUTABLE help2man)

    if(HELP2MAN_EXECUTABLE)
        message(STATUS "Will build man page for bladeRF-cli.")

        if(NOT DEFINED MAN_INSTALL_DIR)
            set(MAN_INSTALL_DIR share/man)
        endif(NOT DEFINED MAN_INSTALL_DIR)

        # Build actual man page
        add_custom_command(
            OUTPUT bladeRF-cli.1
            DEPENDS bladeRF-cli src/cmd/doc/cmd_help.man
            COMMAND ${HELP2MAN_EXECUTABLE}
                --no-info --no-discard-stderr
                --opt-include=${CMAKE_CURRENT_SOURCE_DIR}/../doc/include_man/bladeRF-cli.h2m
                --opt-include=${CMAKE_CURRENT_BINARY_DIR}/src/cmd/doc/cmd_help.man
                --opt-include=${CMAKE_CURRENT_SOURCE_DIR}/../doc/include_man/common.h2m
                --output=bladeRF-cli.1
                ./bladeRF-cli
            WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
        )

        install(
            FILES ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/bladeRF-cli.1
            DESTINATION ${MAN_INSTALL_DIR}/man1
        )

        add_custom_target(bladeRF-cli-manpage ALL DEPENDS bladeRF-cli.1)

    else(HELP2MAN_EXECUTABLE)
        message(FATAL_ERROR "Could not find help2man. bladeRF-cli man page "
                "cannot be built.")
    endif(HELP2MAN_EXECUTABLE)
else(BUILD_BLADERF_CLI_DOCUMENTATION)
    message(STATUS "Not building man page for bladeRF-cli. "
            "(BUILD_BLADERF_CLI_DOCUMENTATION is OFF)")
endif(BUILD_BLADERF_CLI_DOCUMENTATION)

################################################################################
# Installation
################################################################################
if(NOT DEFINED BIN_INSTALL_DIR)
    set(BIN_INSTALL_DIR bin)
endif()

install(TARGETS bladeRF-cli DESTINATION ${BIN_INSTALL_DIR})

################################################################################
# Informational output
################################################################################
message(STATUS "Configured to build bladeRF-cli version: ${VERSION_INFO}")

=== analogdevicesinc/no-OS/adrv9371x/zc706/Makefile ===
## Makefile

include ../../scripts/noos.mk

M_HDF_FILE := $(HDL-DIR)/projects/adrv9371x/zc706/adrv9371x_zc706.sdk/system_top.hdf

include $(NOOS-DIR)/adrv9371x/adrv9371x.mk
include $(NOOS-DIR)/scripts/zynq.mk

=== analogdevicesinc/no-OS/fmcdaq2/kc705/Makefile ===
## Makefile

include ../../scripts/noos.mk

M_HDF_FILE := $(HDL-DIR)/projects/daq2/kc705/daq2_kc705.sdk/system_top.hdf

include $(NOOS-DIR)/fmcdaq2/fmcdaq2.mk
include $(NOOS-DIR)/scripts/microblaze.mk

=== analogdevicesinc/no-OS/fmcdaq2/zcu102/Makefile ===
## Makefile

include ../../scripts/noos.mk

M_HDF_FILE := $(HDL-DIR)/projects/daq2/zcu102/daq2_zcu102.sdk/system_top.hdf

include $(NOOS-DIR)/fmcdaq2/fmcdaq2.mk
include $(NOOS-DIR)/scripts/zynq_u.mk

=== debian/changelog ===
bladerf (0.2019.07-7) unstable; urgency=medium

  * revert Build-Depends-Indep

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 18 Dec 2020 07:43:16 -0500

bladerf (0.2019.07-6) unstable; urgency=medium

  * Update Standards-Version (no changes)
  * debhelper-compat 13
  * update spelling patch, and other lintian gripes

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 17 Dec 2020 22:11:31 -0500

bladerf (0.2019.07-5) unstable; urgency=medium

  * Team upload.
  * Cherry-pick two patches from upstream to fix gcc 10 compatibility.
    (Closes: #957046)
  * Add debian/gitlab-ci.yml.
  * Import repository in the debian-hamradio-team.
  * Remove bladerf.egg-info/ on clean.

 -- Christoph Berg <myon@debian.org>  Sat, 25 Jul 2020 13:49:05 +0200

bladerf (0.2019.07-4) unstable; urgency=medium

  * Correct Breaks:/Replaces: (Closes: #935733)

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 30 Aug 2019 18:20:01 -0400

bladerf (0.2019.07-3) unstable; urgency=medium

  * Handle upgrades with Breaks:/Replaces: (Closes: #935733)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 25 Aug 2019 15:20:11 -0400

bladerf (0.2019.07-2) unstable; urgency=medium

  * Upload to unstable

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 24 Aug 2019 21:33:40 -0400

bladerf (0.2019.07-1) experimental; urgency=medium

  * New upstream release
  * Build with gcc 9 (Closes: #925644)
  * bump libbladerf ABI and upload to experimental

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 14 Aug 2019 23:38:16 -0400

=== debian/control ===
Source: bladerf
Priority: optional
Maintainer: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: cmake (>= 2.8.12),
               debhelper-compat (= 13),
               dh-python,
	       doxygen,
	       graphviz,
               help2man,
	       libad9361-dev,
               libedit-dev,
               libncurses5-dev,
               libtecla-dev | libtecla1-dev,
               libusb-1.0-0-dev [!kfreebsd-any],
               libusb2-dev [kfreebsd-any],
	       pandoc [!kfreebsd-any],
               pkg-config,
               python3-dev,
               python3-setuptools
Standards-Version: 4.5.1
Rules-Requires-Root: no
Section: comm
Homepage: https://www.Nuand.com/bladeRF
Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/bladerf
Vcs-Git: https://salsa.debian.org/debian-hamradio-team/bladerf.git

Package: libbladerf2
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: bladerf
Suggests: bladerf-firmware, bladerf-fpga
Description: Nuand bladeRF software-defined radio device
 The Nuand bladeRF is an open-source software-defined radio (SDR) system,
 comprised of an RF transceiver, a field-programmable gate array (FPGA),
 a microcontroller driving a USB 3.0 interface, and a suite of host
 libraries and drivers to facilitate interaction with the device.
 .
 This package provides the host library.

Package: libbladerf-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libbladerf2 (= ${binary:Version}),
         libc6-dev | libc-dev,
         ${misc:Depends}
Suggests: libbladerf-doc
Description: Nuand bladeRF software-defined radio device (header files)
 The Nuand bladeRF is an open-source software-defined radio (SDR) system,
 comprised of an RF transceiver, a field-programmable gate array (FPGA),
 a microcontroller driving a USB 3.0 interface, and a suite of host
 libraries and drivers to facilitate interaction with the device.
 .
 This package contains the header files required for compiling bladeRF
 applications.

Package: libbladerf-doc
Section: doc
Architecture: all
Depends: libjs-mathjax, ${misc:Depends}
Breaks: libbladerf-dev (<< 0.2019.07)
Replaces: libbladerf-dev (<< 0.2019.07)
Description: Nuand bladeRF software-defined radio device (API documentation)
 The Nuand bladeRF is an open-source software-defined radio (SDR) system,
 comprised of an RF transceiver, a field-programmable gate array (FPGA),
 a microcontroller driving a USB 3.0 interface, and a suite of host
 libraries and drivers to facilitate interaction with the device.
 .
 This package contains libbladeRF API documentation.

Package: bladerf
Architecture: any
Multi-Arch: foreign
Depends: libbladerf2 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Provides: bladerf-host
Conflicts: bladerf-host
Replaces: bladerf-host
Description: Nuand bladeRF software-defined radio device (tools)
 The Nuand bladeRF is an open-source software-defined radio (SDR) system,
 comprised of an RF transceiver, a field-programmable gate array (FPGA),
 a microcontroller driving a USB 3.0 interface, and a suite of host
 libraries and drivers to facilitate interaction with the device.
 .
 This package provides command-line tools for controlling the bladeRF.

Package: python3-bladerf
Section: python
Architecture: any
Multi-Arch: foreign
Depends: libbladerf-dev (= ${binary:Version}),
         python3, ${python3:Depends},
         ${misc:Depends}
Description: Nuand bladeRF software-defined radio device (Python)
 The Nuand bladeRF is an open-source software-defined radio (SDR) system,
 comprised of an RF transceiver, a field-programmable gate array (FPGA),
 a microcontroller driving a USB 3.0 interface, and a suite of host
 libraries and drivers to facilitate interaction with the device.
 .
 This package provides Python bindings for controlling the bladeRF.

Package: bladerf-fpga-hostedx40
Section: contrib/comm
Architecture: all
Depends: ca-certificates, libbladerf2, wget, ${misc:Depends}
Recommends: bladerf
Suggests: bladerf-firmware
Provides: bladerf-fpga
Description: Nuand bladeRF FPGA bitstream downloader (hostedx40)
 This empty package will, at the time of installation, download an appropriate
 FPGA bitstream for using the Nuand bladeRF in a hosted (USB-controlled)
 configuration.  The FPGA bitstream will be downloaded from
 http://Nuand.com/fpga/ and saved to /usr/share/Nuand/bladeRF.
 .
 This bitstream is for the bladeRF x40 with the Altera Cyclone IV
 EP4CE40 FPGA.
 .
 Note that this will not upgrade the bladeRF itself.  That can be done
 with the bladeRF-cli utility.

Package: bladerf-fpga-hostedx115
Section: contrib/comm
Architecture: all
Depends: ca-certificates, libbladerf2, wget, ${misc:Depends}
Recommends: bladerf
Suggests: bladerf-firmware
Provides: bladerf-fpga
Description: Nuand bladeRF FPGA bitstream downloader (hostedx115)
 This empty package will, at the time of installation, download an appropriate
 FPGA bitstream for using the Nuand bladeRF in a hosted (USB-controlled)
 configuration.  The FPGA bitstream will be downloaded from
 http://Nuand.com/fpga/ and saved to /usr/share/Nuand/bladeRF.
 .
 This bitstream is for the bladeRF x115 with the Altera Cyclone IV
 EP4CE115 FPGA.
 .
 Note that this will not upgrade the bladeRF itself.  That can be done
 with the bladeRF-cli utility.

Package: bladerf-fpga-hostedxa4
Section: contrib/comm
Architecture: all
Depends: wget, ${misc:Depends}
Recommends: bladerf
Suggests: bladerf-firmware
Provides: bladerf-fpga
Description: Nuand bladeRF FPGA bitstream downloader (hostedxA4)
 This empty package will, at the time of installation, download an appropriate
 FPGA bitstream for using the Nuand bladeRF in a hosted (USB-controlled)
 configuration.  The FPGA bitstream will be downloaded from
 https://nuand.com/fpga/ and saved to /usr/share/Nuand/bladeRF.
 .
 This bitstream is for the bladeRF 2.0 Micro xA4 with the Altera Cyclone V
 5CEBA4 FPGA.
 .
 Note that this will not upgrade the bladeRF itself.  That can be done
 with the bladeRF-cli utility.

Package: bladerf-fpga-hostedxa9
Section: contrib/comm
Architecture: all
Depends: wget, ${misc:Depends}
Recommends: bladerf
Suggests: bladerf-firmware
Provides: bladerf-fpga
Description: Nuand bladeRF FPGA bitstream downloader (hostedxA9)
 This empty package will, at the time of installation, download an appropriate
 FPGA bitstream for using the Nuand bladeRF in a hosted (USB-controlled)
 configuration.  The FPGA bitstream will be downloaded from
 https://nuand.com/fpga/ and saved to /usr/share/Nuand/bladeRF.
 .
 This bitstream is for the bladeRF 2.0 Micro xA9 with the Altera Cyclone V
 5CEBA9 FPGA.
 .
 Note that this will not upgrade the bladeRF itself.  That can be done
 with the bladeRF-cli utility.

Package: bladerf-firmware-fx3
Section: contrib/comm
Architecture: all
Depends: ca-certificates, libbladerf2, wget, ${misc:Depends}
Recommends: bladerf
Suggests: bladerf-fpga
Provides: bladerf-firmware
Description: Nuand bladeRF firmware downloader (FX3)
 This empty package will, at the time of installation, download an appropriate
 firmware image for using the Nuand bladeRF with a Cypress FX3 USB
 controller.  The image will be downloaded from http://Nuand.com/fx3/
 and saved to /usr/share/Nuand/bladeRF.
 .
 This bitstream will work for either the Nuand bladeRF x40 or the x115.
 .
 Note that this will not upgrade the bladeRF itself.  That can be done
 with the bladeRF-cli utility.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# vim:noet
include /usr/share/dpkg/pkg-info.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
py3default = $(subst .,,$(shell py3versions -dv))

# Test to see if we're a snapshot build by looking for the word
# "SNAPSHOT" in our version.  If so, infer our current version and inject
# it into the build process.
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

ifneq (,$(findstring SNAPSHOT,$(DEB_VERSION)))
	# Format is like: 0.9.0+1SNAPSHOT20131027041813-gitedc468d~saucy
	DVS_SPLIT := $(subst ~, ,$(subst -git, ,$(DEB_VERSION)))
	# Format is like: 0.9.0+1SNAPSHOT20131027041813 edc468d saucy
	DEB_VERSION_GITHASH := $(word 2,$(DVS_SPLIT))
	DEB_VERSION_SERIES := $(word 3,$(DVS_SPLIT))
	# Produce a version suffix like: git-edc468d-ppasaucy
	VERSION_INFO_OVERRIDE := git-$(DEB_VERSION_GITHASH)-ppa$(DEB_VERSION_SERIES)
else
	VERSION_INFO_OVERRIDE := $(DEB_VERSION)
endif

# For tagged PPA release builds, we have a slightly different format...
ifneq (,$(findstring 1ppa,$(DEB_VERSION)))
	# Format is like: 2014.09-rc1-1ppa1~saucy
	DVS_SPLIT := $(subst ~, ,$(subst -1ppa, ,$(DEB_VERSION)))
	# Format is like: 2014.09-rc1 1 saucy
	DEB_VERSION_TAG := $(word 1,$(DVS_SPLIT))
	DEB_VERSION_BUILD := $(word 2,$(DVS_SPLIT))
	DEB_VERSION_SERIES := $(word 3,$(DVS_SPLIT))
	# Produce a version suffix like: 2014.09-rc1-1-ppasaucy
	VERSION_INFO_OVERRIDE := $(DEB_VERSION_TAG)-$(DEB_VERSION_BUILD)-ppa$(DEB_VERSION_SERIES)
endif

override_dh_acc:
	- dh_acc $@
	- cat logs/libbladerf-dev/*/log.txt

override_dh_auto_configure:
	dh_auto_configure -- 	-DVERSION_INFO_OVERRIDE:STRING=$(VERSION_INFO_OVERRIDE) \
							-DCMAKE_BUILD_TYPE=RelWithDebInfo \
							-DCMAKE_INSTALL_DOCDIR="share/doc/libbladerf-doc" \
							-DENABLE_HOST_BUILD=ON \
							-DENABLE_LIBTECLA=ON \
							-DENABLE_LIBEDIT=ON \
							-DENABLE_FX3_BUILD=OFF \
							-DBUILD_DOCUMENTATION=ON \
							-DUDEV_RULES_PATH=/lib/udev/rules.d

override_dh_auto_build:
	dh_auto_build
	python3 host/libraries/libbladeRF_bindings/python/setup.py build

override_dh_auto_install:
	dh_auto_install
	# Use locally installed Mathjax.js
	(cd debian/tmp/usr/share/doc/libbladerf-doc/html && ln -s /usr/share/javascript/mathjax/MathJax.js MathJax.js)
	(cd debian/tmp/usr/share/doc/libbladerf-doc/html && sed --in-place 's_http://cdn.mathjax.org/mathjax/latest/MathJax.js_MathJax.js_' *.html)
	# library soversion named udev rules
	#mv debian/tmp/lib/udev/rules.d/88-nuand.rules debian/tmp/lib/udev/rules.d/88-libbladerf2.rules
	# Python3 bindings
	python3 host/libraries/libbladeRF_bindings/python/setup.py install --root=debian/tmp/ --prefix=/usr
	# per lintian
	rm -f host/examples/bladeRF-cli/sync_trx/.gitignore
	rm -f host/examples/python/txrx/.gitignore

%:
	dh $@ --with python3
